/*
 * URL Shortener API
 * This API is responsible of authetication and the creation, modification and deletion of uris and hooks.
 *
 * OpenAPI spec version: 0.2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.9
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Hook', 'model/URI', 'model/URIRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Hook'), require('../model/URI'), require('../model/URIRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.UrlShortenerApi) {
      root.UrlShortenerApi = {};
    }
    root.UrlShortenerApi.UriApi = factory(root.UrlShortenerApi.ApiClient, root.UrlShortenerApi.Hook, root.UrlShortenerApi.URI, root.UrlShortenerApi.URIRequest);
  }
}(this, function(ApiClient, Hook, URI, URIRequest) {
  'use strict';

  /**
   * Uri service.
   * @module api/UriApi
   * @version 0.2.0
   */

  /**
   * Constructs a new UriApi. 
   * @alias module:api/UriApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the activateURI operation.
     * @callback module:api/UriApi~activateURICallback
     * @param {String} error Error message, if any.
     * @param {module:model/URI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Activate a URI
     * 
     * @param {String} uriId ID of URI to activate
     * @param {module:api/UriApi~activateURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/URI}
     */
    this.activateURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling activateURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = URI;

      return this.apiClient.callApi(
        '/uris/{uriId}/activate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the addURI operation.
     * @callback module:api/UriApi~addURICallback
     * @param {String} error Error message, if any.
     * @param {module:model/URI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new URI
     * 
     * @param {module:model/URIRequest} body URI that needs to be created
     * @param {module:api/UriApi~addURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/URI}
     */
    this.addURI = function(body, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling addURI");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = URI;

      return this.apiClient.callApi(
        '/uris', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deactivateURI operation.
     * @callback module:api/UriApi~deactivateURICallback
     * @param {String} error Error message, if any.
     * @param {module:model/URI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deactivate a URI
     * 
     * @param {String} uriId ID of URI to deactivate
     * @param {module:api/UriApi~deactivateURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/URI}
     */
    this.deactivateURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling deactivateURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = URI;

      return this.apiClient.callApi(
        '/uris/{uriId}/deactivate', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteURI operation.
     * @callback module:api/UriApi~deleteURICallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a URI
     * 
     * @param {String} uriId URI id to delete
     * @param {module:api/UriApi~deleteURICallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling deleteURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/uris/{uriId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getHooksByURI operation.
     * @callback module:api/UriApi~getHooksByURICallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Hook>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieves all the hooks of a URI
     * @param {String} uriId ID of URI to get hooks from
     * @param {module:api/UriApi~getHooksByURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Hook>}
     */
    this.getHooksByURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling getHooksByURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Hook];

      return this.apiClient.callApi(
        '/uris/{uriId}/hooks', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getURI operation.
     * @callback module:api/UriApi~getURICallback
     * @param {String} error Error message, if any.
     * @param {module:model/URI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Find URI by ID
     * 
     * @param {String} uriId ID of URI to return
     * @param {module:api/UriApi~getURICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/URI}
     */
    this.getURI = function(uriId, callback) {
      var postBody = null;

      // verify the required parameter 'uriId' is set
      if (uriId === undefined || uriId === null) {
        throw new Error("Missing the required parameter 'uriId' when calling getURI");
      }


      var pathParams = {
        'uriId': uriId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = URI;

      return this.apiClient.callApi(
        '/uris/{uriId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getURIByUser operation.
     * @callback module:api/UriApi~getURIByUserCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/URI>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Retrieves all the URI of a user
     * @param {Number} userId ID of user to get URI from
     * @param {module:api/UriApi~getURIByUserCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/URI>}
     */
    this.getURIByUser = function(userId, callback) {
      var postBody = null;

      // verify the required parameter 'userId' is set
      if (userId === undefined || userId === null) {
        throw new Error("Missing the required parameter 'userId' when calling getURIByUser");
      }


      var pathParams = {
        'userId': userId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [URI];

      return this.apiClient.callApi(
        '/users/{userId}/uris', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
